WSPSEARCH(1)

NAME
wspsearch - Run Windows Search Protocol searches against a SMB server

SYNOPSIS

wspsearch {//server/share} [--limit=results] [--search=phrase] [--kind=KIND] [--query=QUERY] [-?|--help] [--usage] [-d|--debuglevel=DEBUGLEVEL] [--debug-stdout] [-s|--configfile=CONFIGFILE] [--option=name=value] [-l|--log-basename=LOGFILEBASE] [--leak-report] [--leak-report-full] [-R|--name-resolve=NAME-RESOLVE-ORDER] [-O|--socket-options=SOCKETOPTIONS] [-m|--max-protocol=MAXPROTOCOL] [-n|--netbiosname=NETBIOSNAME] [--netbios-scope=SCOPE] [-W|--workgroup=WORKGROUP] [--realm=REALM] [-U|--user=[DOMAIN/]USERNAME[%PASSWORD]] [-N|--no-pass] [--password=STRING] [--pw-nt-hash] [-A|--authentication-file=FILE] [-P|--machine-pass] [--simple-bind-dn=DN] [--use-kerberos=desired|required|off] [--use-krb5-ccache=CCACHE] [--use-winbind-ccache] [--client-protection=sign|encrypt|off]

DESCRIPTION

This tool is part of the samba(1) suite.

wspsearch is a simple utility to run Windows Search Protocol searches against a SMB server that has the WSP service enabled.

OPTIONS

server
    The SMB server name or IP address to connect to.

sharename
    The name of a share on the server.

--query
    A query specified in simplified AQS-like (Advanced query syntax).

    Basic (AQS) syntax is supported (See SEE ALSO). A query consists of a sequence of queries connected by AND, OR and NOT boolean operators. The query elements are essentially restrictions defined by a property. There are some limitations on the operators supported and some types of properties like enumerated ranges are not supported at all. Additionally syntactically range values are not delimited as specified by AQS (ranges are instead specified as value-value). Some special cases that you see in the windows search UI (for example sizes like 'tiny', 'small', 'large' etc.) are exceptions which are handled more or less as keywords. See EXAMPLES.

--search=phrase
    A simple phrase that is searched across the index

--kind=KIND
    kind one of;

            • Calendar

            • Communication

            • Contact

            • Document

            • Email

            • Feed

            • Folder

            • Game

            • InstantMessage

            • Journal

            • Movie

            • Music

            • Link

            • Note

            • Picture

            • Program

            • RecordedTV

            • SearchFolder

            • Task

            • Video

            • WebHistory

--limit
    A limit on the number of results returned, by default there is a limit of 500 results, a limit of 0 indicates no limit and all results will be returned.

-?|--help
    Print a summary of command line options.

--usage
    Display brief usage message.

-d|--debuglevel=level
    level is an integer from 0 to 10. The default value if this parameter is not specified is 1 for client applications.

    The higher this value, the more detail will be logged to the log files about the activities of the server. At level 0, only critical errors and serious warnings will be logged. Level 1 is a reasonable level for day-to-day running - it generates a small amount of information about operations carried out.

    Levels above 1 will generate considerable amounts of log data, and should only be used when investigating a problem. Levels above 3 are designed for use only by developers and generate HUGE amounts of log data, most of which is extremely cryptic.

    Note that specifying this parameter here will override the log level parameter in the /opt/local/etc/samba/smb.conf file.

--debug-stdout
    This will redirect debug output to STDOUT. By default all clients are logging to STDERR.

--configfile=<configuration file>
    The file specified contains the configuration details required by the client. The information in this file can be general for client and server or only provide client specific like options such as client smb encrypt. See /opt/local/etc/samba/smb.conf for more information. The default configuration file name is determined at compile time.

--option=<name>=<value>
    Set the smb.conf(5) option "<name>" to value "<value>" from the command line. This overrides compiled-in defaults and options read from the configuration file. If a name or a value includes a space, wrap whole --option=name=value into quotes.

-l|--log-basename=logdirectory
    Base directory name for log/debug files. The extension ".progname" will be appended (e.g. log.smbclient, log.smbd, etc...). The log file is never removed by the client.

--leak-report
    Enable talloc leak reporting on exit.

--leak-report-full
    Enable full talloc leak reporting on exit.

-V|--version
    Prints the program version number.

-U|--user=[DOMAIN\]USERNAME[%PASSWORD]
    Sets the SMB username or username and password.

    If %PASSWORD is not specified, the user will be prompted. The client will first check the USER environment variable (which is also permitted to also contain the password separated by a %), then the LOGNAME variable (which is not permitted to contain a password) and if either exists, the value is used. If these environmental variables are not found, the username found in a Kerberos Credentials cache may be used.

    A third option is to use a credentials file which contains the plaintext of the username and password. This option is mainly provided for scripts where the admin does not wish to pass the credentials on the command line or via environment variables. If this method is used, make certain that the permissions on the file restrict access from unwanted users. See the -A for more details.

    Be cautious about including passwords in scripts or passing user-supplied values onto the command line. For security it is better to let the Samba client tool ask for the password if needed, or obtain the password once with kinit.

    While Samba will attempt to scrub the password from the process title (as seen in ps), this is after startup and so is subject to a race.

-N|--no-pass
    If specified, this parameter suppresses the normal password prompt from the client to the user. This is useful when accessing a service that does not require a password.

    Unless a password is specified on the command line or this parameter is specified, the client will request a password.

    If a password is specified on the command line and this option is also defined the password on the command line will be silently ignored and no password will be used.

--password
    Specify the password on the commandline.

    Be cautious about including passwords in scripts or passing user-supplied values onto the command line. For security it is better to let the Samba client tool ask for the password if needed, or obtain the password once with kinit.

    If --password is not specified, the tool will check the PASSWD environment variable, followed by PASSWD_FD which is expected to contain an open file descriptor (FD) number.

    Finally it will check PASSWD_FILE (containing a file path to be opened). The file should only contain the password. Make certain that the permissions on the file restrict access from unwanted users!

    While Samba will attempt to scrub the password from the process title (as seen in ps), this is after startup and so is subject to a race.

--pw-nt-hash
    The supplied password is the NT hash.

-A|--authentication-file=filename
    This option allows you to specify a file from which to read the username and password used in the connection. The format of the file is:

        				username = <value>
        				password = <value>
        				domain   = <value>

    Make certain that the permissions on the file restrict access from unwanted users!

-P|--machine-pass
    Use stored machine account password.

--simple-bind-dn=DN
    DN to use for a simple bind.

--use-kerberos=desired|required|off
    This parameter determines whether Samba client tools will try to authenticate using Kerberos. For Kerberos authentication you need to use dns names instead of IP addresses when connecting to a service.

    Note that specifying this parameter here will override the client use kerberos parameter in the /opt/local/etc/samba/smb.conf file.

--use-krb5-ccache=CCACHE
    Specifies the credential cache location for Kerberos authentication.

    This will set --use-kerberos=required too.

--use-winbind-ccache
    Try to use the credential cache by winbind.

--client-protection=sign|encrypt|off
    Sets the connection protection the client tool should use.

    Note that specifying this parameter here will override the client protection parameter in the /opt/local/etc/samba/smb.conf file.

    In case you need more fine grained control you can use: --option=clientsmbencrypt=OPTION, --option=clientipcsigning=OPTION, --option=clientsigning=OPTION.

EXAMPLES

Search using a basic phrase:

    	'wspsearch -Usomeuser%password //server/share --phrase="cats"'

Search using an AQS like query for a picture whose name starts with p403 or p404:

    	'wspsearch -Usomeuser%password //server/share --query="ALL:$<p403 OR ALL:$<p404 AND System.Kind:picture"'

SEE ALSO

Adanced Query Syntax https://learn.microsoft.com/en-gb/windows/win32/search/-search-3x-advancedquerysyntax

VERSION

This man page is part of version 4.22.1 of the Samba suite.

AUTHOR

The original Samba software and related utilities were created by Andrew Tridgell. Samba is now developed by the Samba Team as an Open Source project similar to the way the Linux kernel is developed.

The wspsearch manpage was written by Noel Power.